
// Anzeigemodus
mode(0);

// Warnung auf dem Bildschirm bei Fließpunktausnahmen.
ieee(1);

// =========================================================
// =                   Lorenzattraktor                     =
// =========================================================


// Erklaerung der Variablen
//    a  -> Parameter 
//    b  -> Parameter
//    c  -> Parameter
//    dt -> Schrittweite

// Initialisierung der Anfangsgroessen
// -----------------------------------
a = 10;
b = 28;
c = 2.666667;
dt = 0.001;

// Anfangsmenue 
// ------------
clc
disp("--------------------")
disp("Der Lorenz-Attraktor")
disp("--------------------")
disp("Edward Lorenz beschrieb 1963 die Konvektionsströmungen innerhalb einer von unten beheizten Flüssigkeits- oder Gasschicht duch die folgenden Differentialgleichungen:")
disp("dx/dt = a(y - x)")
disp("dy/dt = bx - y - xz")
disp("dz/dt = xy - cz")
disp("Dabei sind x, y und z wie folgt definiert:")
disp("x(t): Strömungsgeschwindigkeit innerhalb einer der 6-eckigen Konvektionszellen, die sich in der Schicht bilden. Diese können Sie auch beobachten, wenn Sie Wasser in einem Kochtopf erhitzen.")
disp("y(t): Temperaturdifferenz zwischen auf und absteigender Strömung")
disp("z(t): Abweichung der Veränderung der Temperatur mit der Höhe von seinem Mittelwert.")
disp("Lorenz hat mithilfe dieses Differantialgleichungssystems Wettervorhersagen berechnet. Lorenz bemerkte allerdings bei seinen Berechnungen das deterministische Chaos. Bei den Parametern a=10, b=28 und c=8/3 zeigt dieses System den so genannten Lorenz-Attraktor")
disp("--------------------")
disp("Waehle die Anfangswerte für x(t), y(t) und z(t)")
x(1,1)  = input("x = ");
y(1,1)  = input("y = ");
z(1,1)  = input("z = ");

disp("Wähle die Iterationsschritte")
it = input("it = ");

for i = 2:it
    x(1,i) = x(1,i-1) + (a * (y(1,i-1) - x(1,i-1))) * dt;
    y(1,i) = y(1,i-1) + (x(1,i-1) * (b - z(1,i-1)) - y(1,i-1)) * dt;
    z(1,i) = z(1,i-1) + (x(1,i-1) * y(1,i-1) - c * z(1,i-1)) * dt;
end

param3d(x,y,z)
title('Der Lorenz Attraktor für a=10, b=28 und c=8/3');